package storage

import (
	"code.osinet.fr/fgm/gache/protocol"
	"go/types"
)

type value []byte

type NullStorage types.Nil

func (s NullStorage) Get([]Key) (GetResults, error) {
	return nil, nil
}

func (s NullStorage) Set(key Key, flags Flag, expire Timestamp, value []byte) error {
	return nil
}

func (s NullStorage) Delete(key Key) (protocol.Result, error) {
	return protocol.NotFound, nil
}

func (s NullStorage) FlushAll(delay ...Timestamp) error {
	return nil
}

func (s NullStorage) Quit() {}

func NewNullStorage() Storage {
	return NullStorage{}
}
